<template>
  <ele-modal
    custom-class="ele-dialog-form long-dialog-form"
    :centered="true"
    v-if="visible"
    :visible.sync="visible"
    :title="title"
    :close-on-click-modal="false"
    width="70%"
    append-to-body
    @close="cancel"
    :maxable="true"
    :resizable="true"
  >
    <el-form
      ref="form"
      :model="form"
      :rules="rules"
      class="el-form-box"
      label-width="120px"
    >
      <headerTitle title="合同信息"></headerTitle>
      <el-row>
        <el-col :span="12">
          <el-form-item label="合同类型" prop="type">
            <el-select
              v-model="form.type"
              placeholder="请选择"
              style="width: 100%"
              @change="dictChange"
              :disabled="!!contactData?.id || !!businessOpportunityData.id"
            >
              <el-option
                v-for="item in contractBookTypeList"
                :key="item.code"
                :label="item.name"
                :value="item.code"
              >
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="来源类型" v-if="form.type">
            <el-select
              v-model="form.sourceType"
              placeholder="请选择"
              style="width: 100%"
              :disabled="!!businessOpportunityData.id"
              clearable
              @change="sourceTypeChange(form.type)"
            >
              <el-option
                v-if="item.parentId == form.type"
                v-for="item in sourceTypeList"
                :key="item.code"
                :label="item.name"
                :value="item.code"
              >
              </el-option>
            </el-select>
          </el-form-item>
          <!-- <el-form-item
            prop="remark"
            label="是否首工序"
            v-if="form.categoryId == '1752993827954225153'"
          >
            <el-radio-group v-model="form.isFirstProcess">
              <el-radio v-for="item in processList" :label="item.value">{{
                item.label
              }}</el-radio>
            </el-radio-group>
          </el-form-item> -->
          <el-form-item
            label="核价单"
            prop="sourceName"
            v-if="form.sourceType == 2"
          >
            <el-input
              clearable
              v-model="form.sourceName"
              @click.native="handInquiry"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item
            label="报价单"
            prop="sourceName"
            v-if="form.sourceType == 1"
          >
            <el-input
              clearable
              v-model="form.sourceName"
              @click.native="handQuotation"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item
            label="采购计划"
            prop="sourceName"
            v-if="form.sourceType == 3"
          >
            <el-input
              clearable
              v-model="form.sourceName"
              @click.native="handPlan"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item
            label="商机名称"
            prop="sourceName"
            v-if="form.sourceType == 4"
          >
            <el-input
              clearable
              :disabled="!!businessOpportunityData.id"
              v-model="form.sourceName"
              @click.native="handOpportunity"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item
            label="退货单"
            prop="sourceName"
            v-if="form.sourceType == 5"
          >
            <el-input
              clearable
              v-model="form.sourceName"
              @click.native="handReturnOrder"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item
            label="需求类型"
            prop="requireSourceType"
            v-if="form.type == 2"
            style="margin-bottom: 22px"
          >
            <el-select
              v-model="form.requireSourceType"
              placeholder="请选择"
              style="width: 100%"
              v-if="form.type == 2"
              :disabled="!!form.sourceName"
            >
              <el-option
                v-for="item in requirementSourceType"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item
            label="需求部门"
            prop="requireDeptId"
            v-if="form.type == 2"
          >
            <ele-tree-select
              clearable
              :data="groupTreeData"
              v-model="form.requireDeptId"
              valueKey="id"
              labelKey="name"
              placeholder="请选择"
              @change="change_principalDep"
              default-expand-all
            />
          </el-form-item>

          <el-form-item label="合同名称" prop="contractName">
            <el-input
              clearable
              v-model="form.contractName"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="合同编号" prop="contractNumber">
            <el-input
              clearable
              v-model="form.contractNumber"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item prop="contractFile" label="合同附件">
            <fileMain v-model="form.fileId"></fileMain>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="合同分类" prop="categoryId" style="width: 100%">
            <el-select
              v-model="form.categoryId"
              placeholder="请选择"
              style="width: 100%"
              @change="getListCode"
            >
              <el-option
                v-for="item in categoryList"
                :key="item.id"
                :label="item.name"
                :value="item.id"
              >
              </el-option>
            </el-select>
          </el-form-item>

          <el-form-item label="结算方式" prop="settlementMode">
            <DictSelection
              dictName="结算方式"
              clearable
              v-model="form.settlementMode"
              style="width: 100%"
            >
            </DictSelection>
          </el-form-item>
          <el-form-item
            label="核价清单"
            prop="HJQD"
            v-if="form.sourceType == 2"
          >
            <el-input
              readonly
              v-model="form.HJQD"
              @click.native="handleHJQD"
            ></el-input>
          </el-form-item>
          <el-form-item label="签订日期" prop="contractStartDate">
            <el-date-picker
              v-model="form.contractStartDate"
              @change="setDeliveryDays"
              type="date"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>

          <el-form-item
            label="需求人"
            prop="requireUserId"
            v-if="form.type == 2"
          >
            <personSelect
              ref="directorRef"
              v-model="form.requireUserId"
              @selfChange="salesmanChange"
              :init="false"
            />
          </el-form-item>
          <el-form-item label="结束日期" prop="contractEndDate">
            <el-date-picker
              v-model="form.contractEndDate"
              type="date"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <headerTitle title="基本信息"></headerTitle>
      <el-row>
        <el-col :span="12">
          <el-form-item label="甲方名称" prop="partaName">
            <template v-if="form.type == '2'">
              <el-input
                clearable
                v-model="form.partaName"
                placeholder="请输入"
                v-if="enterprisePage.length <= 1"
              />
              <el-select
                v-if="enterprisePage.length > 1"
                style="width: 100%"
                v-model="form.partaName"
                placeholder="请选择"
                @change="getEnterprise(1)"
              >
                <el-option
                  v-for="item in enterprisePage"
                  :key="item.id"
                  :label="item.name"
                  :value="item.name"
                >
                </el-option>
              </el-select>
            </template>
            <template v-else>
              <el-input
                clearable
                v-model="form.partaName"
                @click.native="handParent"
                placeholder="请选择"
                :disabled="!!contactData?.id || !!businessOpportunityData.id"
              />
            </template>
          </el-form-item>
          <el-form-item
            label="甲方统一社会信用代码"
            prop="partaUnifiedSocialCreditCode"
            class="form_item_label"
          >
            <el-input
              clearable
              v-model="form.partaUnifiedSocialCreditCode"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="甲方联系人" prop="partaLinkName">
            <template v-if="form.type == '2'">
              <el-input
                clearable
                v-model="form.partaLinkName"
                @click.native="handHead"
                placeholder="请选择"
              />
            </template>
            <template v-else>
              <el-select
                v-model="form.partaLinkName"
                placeholder="请选择"
                @change="onchangeLink"
                @focus="selectFocus"
                style="width: 100%"
              >
                <el-option
                  v-for="item in linkNameOptions"
                  :key="item.id"
                  :label="item.linkName"
                  :value="item.id"
                >
                </el-option>
              </el-select>
            </template>
          </el-form-item>
          <el-form-item label="甲方电话" prop="partaTel">
            <el-input
              clearable
              :maxlength="20"
              v-model="form.partaTel"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="甲方传真" prop="partaFax">
            <el-input clearable v-model="form.partaFax" placeholder="请输入" />
          </el-form-item>
          <el-form-item label="	甲方Email" prop="partaEmail">
            <el-input
              clearable
              v-model="form.partaEmail"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="甲方地址" prop="partaAddress">
            <el-input
              clearable
              v-model="form.partaAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <template v-if="form.type == '2'">
            <el-form-item label="乙方名称" prop="partbName">
              <el-input
                clearable
                v-model="form.partbName"
                @click.native="handSupplier"
                placeholder="请输入"
              />
            </el-form-item>
          </template>
          <template v-else>
            <el-form-item label="乙方名称" prop="partbName">
              <el-input
                clearable
                v-model="form.partbName"
                placeholder="请输入"
                v-if="enterprisePage.length <= 1"
              />
              <el-select
                v-if="enterprisePage.length > 1"
                style="width: 100%"
                v-model="form.partbName"
                placeholder="请选择"
                @change="getEnterprise(1)"
              >
                <el-option
                  v-for="item in enterprisePage"
                  :key="item.id"
                  :label="item.name"
                  :value="item.name"
                >
                </el-option>
              </el-select>
            </el-form-item>
          </template>

          <el-form-item
            label="乙方统一社会信用代码"
            prop="partbUnifiedSocialCreditCode"
            class="form_item_label"
          >
            <el-input
              clearable
              v-model="form.partbUnifiedSocialCreditCode"
              placeholder="请输入"
            />
          </el-form-item>
          <el-form-item label="乙方联系人" prop="partbLinkName">
            <template v-if="form.type == '2'">
              <el-select
                style="width: 100%"
                v-model="form.partbLinkName"
                placeholder="请选择"
                @change="onchangeLink"
                @focus="selectFocus"
              >
                <el-option
                  v-for="item in linkNameOptions"
                  :key="item.id"
                  :label="item.linkName"
                  :value="item.id"
                >
                </el-option>
              </el-select>
            </template>
            <template v-else>
              <el-input
                clearable
                v-model="form.partbLinkName"
                @click.native="handHead"
                placeholder="请输入"
              />
            </template>
          </el-form-item>
          <el-form-item prop="partbTel" label="乙方联系电话">
            <el-input clearable v-model="form.partbTel" placeholder="请输入" />
          </el-form-item>
          <el-form-item prop="partbFax" label="乙方传真">
            <el-input clearable v-model="form.partbFax" placeholder="请输入" />
          </el-form-item>

          <el-form-item label="乙方Email" prop="partbEmail">
            <el-input
              clearable
              v-model="form.partbEmail"
              placeholder="请输入"
            />
          </el-form-item>

          <el-form-item label="乙方地址" prop="partbAddress">
            <el-input
              clearable
              v-model="form.partbAddress"
              placeholder="请输入"
            />
          </el-form-item>
        </el-col>
      </el-row>
      <el-tabs v-model="activeName" style="margin-top: 15px" type="border-card">
        <el-tab-pane label="物品清单" name="1">
          <inventoryTable1
            ref="inventoryTable"
            :contractStartDate="this.form.contractStartDate"
            :isCustomerMark="form.type == '1'"
            :isSupplierMark="form.type == '2'"
            :customerMark="form.customerMark"
            :isDiscountTotalPrice="true"
            :contractBookType="form.type"
            :pricingWay="form.pricingWay"
            :isChangeCount="false"
            @setDiscountTotalPrice="setDiscountTotalPrice"
            :isTemporary="true"
            :isSalesRecord="form.type"
            :cacheKeyUrl="cacheKeyUrl"
            
          ></inventoryTable1>
        </el-tab-pane>
        <el-tab-pane
          label="带料清单"
          name="2"
          v-if="form.categoryId == '1752993827954225153'"
        >
          <inventoryTable
            ref="rawDetailListRef"
            :detailType="1"
            :contractStartDate="this.form.contractStartDate"
            :isCustomerMark="form.type == '1'"
            :customerMark="form.customerMark"
            :isDiscountTotalPrice="true"
            :contractBookType="form.type"
            :pricingWay="form.pricingWay"
          ></inventoryTable>
        </el-tab-pane>
        <el-tab-pane
          label="产出清单"
          name="3"
          v-if="form.categoryId == '1752993827954225153'"
        >
          <inventoryTable
            ref="outputDetailListRef"
            :detailType="2"
            :contractStartDate="this.form.contractStartDate"
            :isCustomerMark="form.type == '1'"
            :customerMark="form.customerMark"
            :isDiscountTotalPrice="true"
            :contractBookType="form.type"
            :pricingWay="form.pricingWay"
          ></inventoryTable>
        </el-tab-pane>
      </el-tabs>

      <headerTitle
        :title="form.type == '2' ? '付款方式' : '收款方式'"
        style="margin-top: 30px"
      ></headerTitle>
      <paymentList ref="paymentListTable" />
    </el-form>

    <div slot="footer" class="footer">
      <el-button type="primary" @click="save" v-click-once>保存</el-button>
      <el-button
        type="primary"
        v-if="isNeed_process_is_close"
        @click="save('sub')"
        >提交</el-button
      >
      <el-button @click="cancel">返回</el-button>
    </div>

    <parentList ref="parentRef" @changeParent="changeParent"></parentList>
    <inquiryManageList
      generatedType="contract"
      ref="inquiryManageRef"
      @changeInquiryManageList="changeInquiryManageList"
    ></inquiryManageList>
    <inquiryList
      ref="inquiryListRef"
      @changeParent="changeInquiryList"
    ></inquiryList>
    <quotationList
      ref="quotationListRef"
      @changeParent="changeQuotationList"
      :contactData="contactData"
      :businessOpportunityData="businessOpportunityData"
    ></quotationList>
    <supplierList
      ref="supplierListRef"
      :classType="2"
      @changeParent="changeSupplier"
    ></supplierList>
    <head-list ref="headRef" @changeParent="changePersonel"></head-list>
    <!-- 商机   -->
    <opportunity-dialog
      :opportunityDialogFlag.sync="opportunityDialogFlag"
      v-if="opportunityDialogFlag"
      ref="opportunityDialogRef"
      :contactData="contactData"
      @changeParent="getOpportunityDetail"
    ></opportunity-dialog>
    <!--  退货  -->
    <return-order-dialog
      :returnOrderDialogFlag.sync="returnOrderDialogFlag"
      :contactData="contactData"
      v-if="returnOrderDialogFlag"
      @changeParent="getReturnOrderInfo"
    >
    </return-order-dialog>
    <generate-contracts-dialog1
      :isContractBook="true"
      v-if="generateContractsDialogFlag1"
      ref="generateContractsDialogRef"
      :generate-contracts-dialog-flag1.sync="generateContractsDialogFlag1"
      @changeParent="changeInquiryDetailList"
    ></generate-contracts-dialog1>
    <process-submit-dialog
      api-fun-name="contractStatusAPI"
      :processSubmitDialogFlag.sync="processSubmitDialogFlag"
      v-if="processSubmitDialogFlag"
      ref="processSubmitDialogRef"
      @reload="reload"
    ></process-submit-dialog>
  </ele-modal>
</template>

<script>
  import { emailReg, telReg } from 'ele-admin';
  import { acceptUnpackoptions } from '@/enum/dict';
  import inventoryTable from './inventoryTable.vue';
  import inventoryTable1 from '@/BIZComponents//inventoryTable.vue';
  import inquiryList from './inquiryList.vue';
  import quotationList from './quotationList.vue';
  import fileMain from '@/components/addDoc/index';
  import fileUpload from '@/components/upload/fileUpload';
  import dictMixins from '@/mixins/dictMixins';
  import parentList from '@/views/saleManage/contact/components/parentList.vue';
  import {
    getDetail,
    UpdateInformation,
    addInformation,
    submit
  } from '@/api/contractManage/contractBook';
  import {
    contactDetail,
    updateRelationStatus
  } from '@/api/saleManage/contact';
  import { getDetail as getOpportunityInfo } from '@/api/saleManage/businessOpportunity';
  import { isHasGeneratedContractAPI as BJisHasGeneratedContractAPI } from '@/api/saleManage/quotation';
  import { isHasGeneratedContractAPI as SJisHasGeneratedContractAPI } from '@/api/saleManage/businessOpportunity';
  import { getcontactlink } from '@/api/saleManage/businessFollow';
  import headList from '@/BIZComponents/user-select/user-select.vue';
  import supplierList from '@/views/purchasingManage/supplierManage/components/parentList.vue';
  import paymentList from './paymentList.vue';
  import { copyObj } from '@/utils/util';
  import { enterprisePage } from '@/api/contractManage/contractBook';
  import inquiryManageList from '@/views/purchasingManage/inquiryManage/components/inquiryManage-list.vue';
  import { getplanDetail } from '@/api/purchasingManage/purchasePlanManage';
  import opportunityDialog from '@/views/financialManage/components/opportunityDialog.vue';
  import { getOpportunityDetail } from '@/api/saleManage/businessOpportunity';
  import { isHasGeneratedContractPI } from '@/api/purchasingManage/inquiryManage';
  import returnOrderDialog from '@/views/saleManage/saleOrder/customerReturnOrder/returnOrderDialog.vue';
  import {
    getReturnSaleOrderrecordDetail,
    saleReturnGetByIdAPI
  } from '@/api/saleManage/returnGoods';
  import generateContractsDialog1 from './generateContractsDialog1.vue';
  import processSubmitDialog from '@/BIZComponents/processSubmitDialog/processSubmitDialog.vue';
  import personSelect from '@/components/CommomSelect/person-select.vue';
  import { listOrganizations } from '@/api/system/organization';
  import { requirementSourceType } from '@/enum/dict.js';
  import { listCode, getCode } from '@/components/addDoc/api/index.js';
  export default {
    props: {
      categoryTreeList: Array,
      contactData: {
        type: Object,
        default: () => {
          return {};
        }
      },
      curNodeData: {
        type: Object,
        default: () => {
          return {};
        }
      },

      businessOpportunityData: {
        type: Object,
        default: () => {
          return {};
        }
      }
    },
    mixins: [dictMixins],
    components: {
      processSubmitDialog,
      generateContractsDialog1,
      returnOrderDialog,
      opportunityDialog,
      inquiryManageList,
      fileUpload,
      headList,
      paymentList,
      inventoryTable,
      supplierList,
      parentList,
      inquiryList,
      quotationList,
      fileMain,
      inventoryTable1,
      personSelect
    },
    data() {
      let formDef = {
        id: '',
        contractEndDate: '',
        contractFile: [],
        contractName: '',
        contractNumber: '',
        contractStartDate: '',
        opportunityId: '',
        categoryName: '',
        categoryId: '',
        sourceId: '',
        sourceType: '',
        sourceName: '',
        partaUnifiedSocialCreditCode: '',
        partbUnifiedSocialCreditCode: '',
        partaAddress: '',
        partaEmail: '',
        partaFax: '',
        partaId: '',
        partaLinkId: '',
        partaLinkName: '',
        partaName: '',
        partaTel: '',
        partbAddress: '',
        partbEmail: '',
        partbFax: '',
        partbId: '',
        partbLinkId: '',
        partbLinkName: '',
        partbName: '',
        partbTel: '',
        settlementModeName: '结算方式',
        settlementMode: '4',
        pricingWay: 1,
        customerMark: '',
        requireSourceType: '',
        requireSourceTypeName: '',
        totalPrice: null,
        isFirstProcess: 0,
        requireDeptId: '',
        requireUserId: '',
        requireUserName: '',
        requireDeptName: '',
        type: '', //1=销售合同  2=采购合同
        typeName: '',
        fileId: [] //附件集合
      };

      return {
        fullscreen: false,
        requirementSourceType,
        cacheKeyUrl: 'eos-contractManage-contractBook-inventoryTabl',
        activeName: '1',
        payWayOptions: [],
        delDetailIds: [],
        paymentTypeOptions: [
          { id: 1, name: '固定' },
          { id: 2, name: '分期' }
        ],
        pricingWayList: [
          { id: 1, name: '按数量计价' },
          { id: 2, name: '按重量计价' }
        ],

        processList: [
          {
            label: '是',
            value: 1
          },
          {
            label: '否',
            value: 0
          }
        ],
        contractBookTypeList: [],
        sourceTypeList: [
          {
            code: 1,
            name: '报价单',
            parentId: '1'
          },
          {
            code: 2,
            name: '核价单',
            parentId: '2'
          },
          {
            code: 3,
            name: '采购计划',
            parentId: '2'
          },
          {
            code: 4,
            name: '商机',
            parentId: '1'
          },
          {
            code: 5,
            name: '退货单',
            parentId: '1'
          }
        ],
        categoryList: [],

        linkNameOptions: [],
        acceptUnpackoptions,
        visible: false,
        processSubmitDialogFlag: false,
        opportunityDialogFlag: false,
        returnOrderDialogFlag: false,
        generateContractsDialogFlag1: false,
        title: '',
        row: {},
        formDef,
        form: copyObj(formDef),
        // removeBankList: [],
        // removeLinkList: [],
        tableBankData: [],
        tableLinkData: [],
        rules: {
          type: [
            { required: true, message: '请选择合同类型', trigger: 'change' }
          ],
          HJQD: [
            { required: true, message: '请选择核价清单', trigger: 'change' }
          ],
          settlementMode: [
            { required: true, message: '请选择合结算方式', trigger: 'change' }
          ],

          categoryId: [
            { required: true, message: '请选择合同分类', trigger: 'change' }
          ],
          contractNumber: [
            { required: true, message: '请输入自带编号', trigger: 'change' }
          ],
          contractName: [
            { required: true, message: '请输入合同名称', trigger: 'blur' }
          ],
          partaName: [
            { required: true, message: '请选择甲方名称', trigger: 'change' }
          ],
          partaLinkName: [
            { required: true, message: '请选择甲方联系人', trigger: 'change' }
          ],
          acceptUnpack: [
            { required: true, message: '请选择是否接受', trigger: 'change' }
          ],
          partaTel: [
            {
              required: true,
              pattern: telReg,
              message: '请输入甲方联系电话',
              trigger: 'blur'
            }
          ],
          deliveryDate: [
            { required: true, message: '请选择交货日期', trigger: 'change' }
          ],

          partbName: [
            { required: true, message: '请输入乙方名称', trigger: 'change' }
          ],
          partbLinkName: [
            { required: true, message: '请输入乙方联系人', trigger: 'change' }
          ],
          partbTel: [
            {
              required: true,
              pattern: telReg,
              message: '请输入乙方联系电话',
              trigger: 'blur'
            }
          ],
          partaEmail: [
            { pattern: emailReg, message: '邮箱格式不正确', trigger: 'blur' }
          ],
          contractStartDate: [
            { required: true, message: '请选择签订日期', trigger: 'change' }
          ],
          contractEndDate: [
            { validator: this.validateEndDate, trigger: 'blur' }
          ]
        },
        enterprise: {
          address: '',
          unifiedSocialCreditCode: '',
          tel: '',
          name: ''
        },
        // 提交状态
        loading: false,
        // 是否是修改
        isUpdate: false,

        enterprisePage: [],
        create: false,
        source: '',
        businessId: '',
        groupTreeData: [],
        // 组织机构平铺数据
        groupData: []
      };
    },
    created() {
      this.getGroupAll();
      enterprisePage({
        pageNum: 1,
        size: 200
      }).then((res) => {
        this.enterprisePage = [];
        this.enterprisePage.push(...res.list);
        this.getEnterprise();
      });
    },

    methods: {
      setDiscountTotalPrice(val) {
        this.form.discountTotalPrice = val;
        this.$nextTick(() => {
          this.$refs.paymentListTable.setDiscountAmount(val);
        });
      },
      // 获取公司数据
      getGroupAll() {
        listOrganizations().then((list) => {
          this.groupData = list;
          this.groupTreeData = this.$util.toTreeData({
            data: list,
            idField: 'id',
            parentIdField: 'parentId'
          });
        });
      },

      // 选择负责人部门
      change_principalDep(id) {
        const info = this.groupData.find((e) => e.id == id);
        this.form.requireDeptName = info.name;
        this.form.requireUserId = '';
        this.form.requireUserName = '';
        // 根据部门获取人员
        this.$nextTick(() => {});
        this.getrequireUser(id);
      },

      getrequireUser(groupId) {
        if (groupId) {
          this.$refs.directorRef.getList({ groupId });
        }
      },
      //开始日期验证
      validateStartDate(rule, value, callback) {
        if (this.form.contractEndDate && value > this.form.contractEndDate) {
          callback(new Error('开始日期不能大于结束日期'));
        } else {
          callback();
        }
      },
      //结束日期验证
      validateEndDate(rule, value, callback) {
        if (
          this.form.contractEndDate &&
          this.form.contractStartDate &&
          value < this.form.contractStartDate
        ) {
          callback(new Error('结束日期不能小于开始日期'));
        } else {
          callback();
        }
      },

      //选择供应商
      async changeSupplier(obj) {
        if (!obj.id) {
          return;
        }

        const { base, other } = await contactDetail(obj.id);

        this.form = Object.assign({}, this.form, {
          partbId: base.id,
          partbName: base.name,
          partbAddress: other.addressName
            ? other.addressName + other.address
            : base.addressName + other.address,
          partbLinkId: '',
          partbLinkName: '',
          partbEmail: '',
          partbTel: '',
          partbUnifiedSocialCreditCode: obj.unifiedSocialCreditCode,
          customerMark: base.serialNo
        });
        await this.getLinkInfo(obj.id);
        this.$nextTick(() => {
          this.setProductInfo();
          let firstLink =
            this.linkNameOptions.find((item) => item.ifChief == 1) || {};
          this.form = Object.assign({}, this.form, {
            partbLinkId: firstLink.id || this.linkNameOptions[0]?.id,
            partbLinkName:
              firstLink.linkName || this.linkNameOptions[0]?.linkName,
            partbTel:
              firstLink.mobilePhone || this.linkNameOptions[0]?.mobilePhone
          });
        });
      },
      //获取编码list
      async getListCode() {
        let categoryData = this.categoryList.find(
          (item) => item.id == this.form.categoryId
        );
        let list = await listCode(categoryData.code);
        if (list?.length > 0) {
          this.$set(this.form, 'contractNumber', await getCode(list[0]?.id));
        } else {
          this.$set(this.form, 'contractNumber', '');
        }
      },
      //获取详情
      async getDetailData(id) {
        this.businessId = id;

        this.loading = true;
        const data = await getDetail(id);
        let { contractVO } = data;
        this.form = contractVO;

        this.loading = false;
        if (data) {
          this.form.HJQD = this.form.partbName;

          this.$nextTick(() => {
            this.dictChange(contractVO.type, 'init');
            this.getrequireUser(contractVO.requireDeptId);

            // if (this.form.fileId) {
            //   this.form.fileId = JSON.parse(this.form.fileId);
            // }

            this.$refs.inventoryTable &&
              this.$refs.inventoryTable.putTableValue(data);
            this.$refs.paymentListTable &&
              this.$refs.paymentListTable.putTableValue(
                data.receiptPaymentList
              );
            this.$refs.paymentListTable &&
              this.$refs.paymentListTable.setDiscountAmount(
                contractVO.discountTotalPrice
              );
            this.$refs.rawDetailListRef &&
              this.$refs.rawDetailListRef.putTableValueNew(contractVO.rawList); //原料
            this.$refs.outputDetailListRef &&
              this.$refs.outputDetailListRef.putTableValueNew(
                contractVO.outputList
              );

            this.getLinkInfo(
              contractVO.type == '2' ? contractVO.partbId : contractVO.partaId
            );
          });
        }
      },
      //签订日期 更新
      setDeliveryDays() {
        this.$refs.inventoryTable.setDeliveryDays('', '', '', true);
      },

      //更新联系人数据
      async getLinkInfo(contactId) {
        const data = await getcontactlink({ contactId });
        if (data && data?.length) {
          this.linkNameOptions = data;
        }
      },
      handleHJQD() {
        if (!this.form.sourceId) return this.$message.warning('请先选择核价单');
        this.generateContractsDialogFlag1 = true;
        this.$nextTick(() => {
          this.$refs.generateContractsDialogRef.open({
            id: this.form.sourceId
          });
        });
      },
      selectFocus() {
        if (this.linkNameOptions.length === 0) {
          return this.$message.warning('请先选择名称');
        }
      },
      //选择合同类型
      dictChange(val, type) {
        this.categoryList = copyObj(
          this.contractBookTypeList.find((item) => item.code == val).children
        );
        if (type == 'init') {
          return;
        }
        let typeName = '';
        if (val)
          typeName =
            this.contractBookTypeList.find((item) => item.code == val)?.name ||
            '';
        this.form = Object.assign({}, this.form, {
          typeName: typeName || val.dictValue,
          contractName: '',
          sourceType: '',
          sourceId: '',
          sourceName: '',
          partaAddress: '',
          partaEmail: '',
          partaFax: '',
          partaId: '',
          partaLinkId: '',
          partaLinkName: '',
          partaName: '',
          partaTel: '',
          partbAddress: '',
          partbEmail: '',
          partbFax: '',
          partbId: '',
          partbLinkId: '',
          partbLinkName: '',
          partbName: '',
          partbTel: '',
          partaUnifiedSocialCreditCode: '',
          partbUnifiedSocialCreditCode: '',
          categoryName: '',
          categoryId: ''
        });
        this.getEnterprise();
        this.changePersonel();
      },
      //选择来源类型
      sourceTypeChange(val, type) {
        if (this.contactData.id) {
          return;
        }
        this.form = Object.assign({}, this.form, {
          contractName: '',
          sourceId: '',
          sourceName: '',
          partaAddress: '',
          partaEmail: '',
          partaFax: '',
          partaId: '',
          partaLinkId: '',
          partaLinkName: '',
          partaName: '',
          partaTel: '',
          partbAddress: '',
          partbEmail: '',
          partbFax: '',
          partbId: '',
          partbLinkId: '',
          partbLinkName: '',
          partbName: '',
          partbTel: '',
          partaUnifiedSocialCreditCode: '',
          partbUnifiedSocialCreditCode: ''
          // categoryName: '',
          // categoryId: ''
        });
        this.getEnterprise();
        this.changePersonel();
      },
      getEnterprise(type) {
        let key = this.form.type == '1' || !this.form.type ? 'partb' : 'parta';
        let keyArr = [
          key + 'Name',
          key + 'UnifiedSocialCreditCode',
          key + 'Fax',
          key + 'Address'
        ];
        if (type === 1) {
          let data = this.enterprisePage.find(
            (item) => item.name == this.form[keyArr[0]]
          );
          this.form[keyArr[0]] = data.name;
          this.form[keyArr[1]] = data.unifiedSocialCreditCode;
          this.form[keyArr[2]] = data.fax;
          this.form[keyArr[3]] = data.address;
          return;
        }
        if (this.enterprisePage.length > 0) {
          this.form[keyArr[0]] =
            this.form[keyArr[0]] || this.enterprisePage[0].name;
          this.form[keyArr[1]] =
            this.form[keyArr[1]] ||
            this.enterprisePage[0].unifiedSocialCreditCode;
          this.form[keyArr[2]] =
            this.form[keyArr[2]] || this.enterprisePage[0].fax;
          this.form[keyArr[3]] =
            this.form[keyArr[3]] || this.enterprisePage[0].address;
        }
      },
      //选择合同分类
      // treeChange(val) {
      //   //这里eladmin组件有bug，要手动验证下
      //   this.$set(this.form, 'categoryId', val);
      //   this.$refs.form.validateField('categoryId');
      // },
      //选择下拉框
      onchangeLink(selectedOptions) {
        if (this.form.type == '2') {
          const option = this.linkNameOptions.find(
            (opt) => opt.id === selectedOptions
          );
          this.form = Object.assign({}, this.form, {
            partbEmail: option?.email,
            partbLinkName: option?.linkName || '',
            partbTel: option?.mobilePhone || option?.phone || '',
            partbLinkId: option?.id
          });
        } else {
          const option = this.linkNameOptions.find(
            (opt) => opt.id === selectedOptions
          );
          this.form = Object.assign({}, this.form, {
            partaEmail: option?.email,
            partaLinkName: option?.linkName || '',
            partaTel: option?.mobilePhone || option?.phone || '',
            partaLinkId: option?.id
          });
        }
      },

      handHead(title) {
        if (this.form.type == '2') {
          let item = {
            id: this.form.partaLinkId
          };
          this.$refs.headRef.open(item);
        } else {
          let item = {
            id: this.form.partbLinkId
          };
          this.$refs.headRef.open(item);
        }
      },

      //选择乙方人和采购合同下的甲方人回调
      changePersonel(obj, index, title) {
        if (!obj) {
          obj = this.$store.getters.user.info;
          obj.id = obj.userId;
        }
        if (this.form.type == '2') {
          this.$set(this.form, 'partaLinkId', obj.id);
          this.$set(this.form, 'partaLinkName', obj.name);
          this.$set(this.form, 'partaTel', obj.phone);
          this.$set(this.form, 'partaEmail', obj.email);
        } else {
          this.$set(this.form, 'partbLinkId', obj.id);
          this.$set(this.form, 'partbLinkName', obj.name);
          this.$set(this.form, 'partbTel', obj.phone);
          this.$set(this.form, 'partbEmail', obj.email);
        }
      },
      //选择客户回调
      async changeParent(obj) {
        if (!obj.id) {
          return;
        }
        const { base, other } = await contactDetail(obj.id);
        this.form = Object.assign({}, this.form, {
          partaId: base.id,
          partaName: base.name,
          partaAddress: other.addressName
            ? other.addressName + other.address
            : base.addressName + other.address,
          partaLinkId: '',
          partaLinkName: '',
          partaEmail: '',
          partaTel: '',
          customerMark: base.serialNo,
          partaUnifiedSocialCreditCode: base.unifiedSocialCreditCode
        });
        await this.getLinkInfo(obj.id);

        this.$nextTick(() => {
          this.setProductInfo();
          let firstLink =
            this.linkNameOptions.find((item) => item.ifChief == 1) || {};
          this.form = Object.assign({}, this.form, {
            partaLinkId: firstLink.id || this.linkNameOptions[0]?.id,
            partaLinkName:
              firstLink.linkName || this.linkNameOptions[0]?.linkName,
            partaTel:
              firstLink.mobilePhone || this.linkNameOptions[0]?.mobilePhone
          });
        });
      },
      setProductInfo() {
        if (this.$refs.inventoryTable && this.$refs.inventoryTable.form) {
          this.$refs.inventoryTable?.form?.datasource.forEach((item, index) => {
            if (this.form.type == 1) {
              this.$set(
                this.$refs.inventoryTable?.form?.datasource[index],
                'customerMark',
                item.customerMark || this.form.customerMark
              );
            } else {
              this.$set(
                this.$refs.inventoryTable?.form?.datasource[index],
                'customerMark',
                item.customerMark || this.form.customerMark
              );
            }
          });
        }
      },
      //选择采购合同的乙方
      handSupplier() {
        let item = {
          id: this.form.partbId
        };
        this.$refs.supplierListRef.open(item);
      },
      handParent() {
        let item = {
          id: this.form.contactId
        };
        this.$refs.parentRef.open(item);
      },

      async open(type, row, create = false, source) {
        this.title = type === 'add' ? '新增' : '修改';
        this.activeName = '1';
        this.row = row;
        this.visible = true;
        this.create = create;
        this.source = source;
        this.contractBookTypeList = copyObj(this.categoryTreeList[0].children);

        if (type == 'add') {
          let userInfo = this.$store.getters.user.info;
          this.isUpdate = false;
          userInfo.id = userInfo.userId;
          this.changePersonel();
          this.form.contractStartDate = new Date();
          if (row?.contractVO?.type) {
            this.dictChange(row.contractVO.type, 'init');
          }
          if (this.contactData.id) {
            this.form.type = '1';

            this.dictChange('1');
            this.changeParent(this.contactData);
          }
          if (this.businessOpportunityData.id) {
            this.form.type = '1';
            this.dictChange('1');
            this.form.sourceType = 4;
            this.getOpportunityDetail(this.businessOpportunityData);
          }

          this.$nextTick(() => {
            this.$refs.paymentListTable.defaultList();
          });
          if (this.curNodeData?.id) {
            this.form.type =
              this.curNodeData.parentCode || this.curNodeData.code;
            this.dictChange(this.form.type);
            if (this.curNodeData.parentCode) {
              this.form.categoryId = this.curNodeData.id;
              await this.getListCode();
            }
          }

          if (create) {
            this.create = create;
            //核价单生成的合同
            this.$nextTick(async () => {
              this.setValue(row);
              if (source == 'inquiryManage') {
                console.log(row, 'row');
                //核价单是否生成过合同
                this.$nextTick(() => {
                  this.$refs.rawDetailListRef &&
                    this.$refs.rawDetailListRef.putTableValueNew(
                      row.contractVO?.rawList
                    ); //原料
                  this.$refs.outputDetailListRef &&
                    this.$refs.outputDetailListRef.putTableValueNew(
                      row.contractVO?.outputList
                    );
                });
                let res = await isHasGeneratedContractPI({
                  inquiryIds: [row.contractVO.sourceId],
                  supplierId: row.contractVO.partbId
                });
                if (res.result) this.$message.warning(res.message);
                this.$refs.inventoryTable.discountInputByOrder(
                  row.contractVO.discountTotalPrice
                );
              }
              if (source == 'quotation') {
                //报价单是否生成过合同
                let res = await BJisHasGeneratedContractAPI(
                  row.contractVO.sourceId
                );
                if (res) this.$message.warning('该报价单已生成过合同，请注意');
              }
            });
          }
        } else {
          this.isUpdate = true;
          await this.getDetailData(row.id);
        }
      },
      //赋值
      async setValue(row) {
        let { contractVO } = row;
        contractVO = {
          ...contractVO,
          categoryId: contractVO.categoryId || this.form.categoryId,
          categoryName: contractVO.categoryName || this.form.categoryName,
          contractStartDate:
            contractVO.contractStartDate || this.form.contractStartDate,
          contractEndDate:
            contractVO.contractEndDate || this.form.contractEndDate,
          pricingWay: 1
        };
        this.form = contractVO;
        this.form.HJQD = this.form.partbName;
        this.$refs.inventoryTable &&
          this.$refs.inventoryTable.putTableValue(row);
        this.$refs.paymentListTable &&
          this.$refs.paymentListTable.putTableValue(row.receiptPaymentList);
        this.$refs.paymentListTable &&
          this.$refs.paymentListTable.setDiscountAmount(
            contractVO.discountTotalPrice
          );
        this.getEnterprise();
        await this.getLinkInfo(
          contractVO.type == '2' ? contractVO.partbId : contractVO.partaId
        );
        this.$nextTick(() => {
          this.getrequireUser(contractVO.requireDeptId);
          let firstLink =
            this.linkNameOptions.find((item) => item.ifChief == 1) || {};
          let LinkId = [1, 4, 5].includes(this.form.sourceType)
            ? 'partaLinkId'
            : 'partbLinkId';
          let LinkName = [1, 4, 5].includes(this.form.sourceType)
            ? 'partaLinkName'
            : 'partbLinkName';
          let Tel = [1, 4, 5].includes(this.form.sourceType)
            ? 'partaTel'
            : 'partbTel';
          this.$set(
            this.form,
            LinkId,
            firstLink.id || this.linkNameOptions[0]?.id
          );
          this.$set(
            this.form,
            LinkName,
            firstLink.linkName || this.linkNameOptions[0]?.linkName
          );
          this.$set(
            this.form,
            Tel,
            firstLink.mobilePhone || this.linkNameOptions[0]?.mobilePhone
          );
          this.changePersonel();
          if (contractVO.type == 1) {
            this.changeParent({ id: contractVO.partaId });
          } else {
            this.changeSupplier({ id: contractVO.partbId });
          }
        });
      },

      salesmanChange(val, info) {
        this.otherForm.salesmanName = info.name;
      },

      ifChiefChange(value, idx) {
        if (value === 1) {
          this.tableLinkData.forEach((e) => (e.ifChief = 0));
          this.tableLinkData[idx].ifChief = 1;
        }
      },

      // getValidate() {
      //   return new Promise((resolve, reject) => {
      //     this.$refs.form.validate((valid) => {
      //       if (!valid) {
      //         reject(false);
      //       } else {
      //         resolve(true);
      //       }
      //     });
      //   });
      // },
      getValidate() {
        return Promise.all([
          new Promise((resolve, reject) => {
            this.$refs.form.validate((valid) => {
              if (!valid) {
                reject(false);
              } else {
                resolve(true);
              }
            });
          }),
          new Promise((resolve, reject) => {
            this.$refs.inventoryTable.validateForm((valid) => {
              if (!valid) {
                reject(false);
              } else {
                resolve(true);
              }
            });
          }),
          new Promise((resolve, reject) => {
            this.$refs.paymentListTable.validateForm((valid) => {
              if (!valid) {
                reject(false);
              } else {
                resolve(true);
              }
            });
          })
        ]);
      },
      async save(type) {
        try {
          await this.getValidate();
          let isTemporary = [];
          // 表单验证通过，执行保存操作
          this.loading = true;

          if (!this.isUpdate) {
            delete this.form.id;
          }
          let [totalPrice, discountTotalPrice] =
            this.$refs.inventoryTable.getPrice();
          this.form.totalPrice = totalPrice;
          this.form.discountTotalPrice = discountTotalPrice;
          if (this.form.categoryId) {
            this.form.categoryName = this.findNameById(
              this.categoryTreeList,
              this.form.categoryId
            );
          }
          this.form.settlementModeName = this.getDictValue(
            '结算方式',
            this.form.settlementMode
          );
          this.form.requireSourceTypeName = this.requirementSourceType.find(
            (item) => item.value == this.form.requireSourceType
          )?.label;
          // if (this.form.fileId) {
          //   this.form.fileId = JSON.stringify(this.form.fileId);
          // } else {
          //   this.form.fileId = '[]';
          // }
          const rawDetailList =
            (this.$refs.rawDetailListRef &&
              this.$refs.rawDetailListRef.getTableValue()) ||
            [];
          const outputDetailList =
            (this.$refs.outputDetailListRef &&
              this.$refs.outputDetailListRef.getTableValue()) ||
            [];
          let commitData = Object.assign(
            {},
            {
              contract: this.form,
              productList: [
                ...this.$refs.inventoryTable.getTableValue(),
                ...rawDetailList,
                ...outputDetailList
              ],
              receiptPaymentList: this.$refs.paymentListTable.getTableValue()
            }
          );

          // commitData.productList.forEach((item) => {
          //   if (!item.productCode) {
          //     isTemporary.push(item.productName);
          //   }
          // });
          // if (isTemporary.length > 0) {
          //   this.$message.error(
          //     isTemporary.toString() +
          //       '是临时产品，无法创建合同，请先去主数据维护！'
          //   );

          //   return;
          // }
          let relationId =
            this.form.type == 1 ? this.form.partaId : this.form.partbId;
          if (this.isUpdate) {
            UpdateInformation(commitData)
              .then((res) => {
                this.loading = false;
                this.$message.success('修改成功');
                updateRelationStatus([relationId]);
                if (type === 'sub') {
                  this.contractBookSubmit(res);
                  return;
                }
                this.cancel();
                this.$emit('done');
              })
              .catch((e) => {
                //this.loading = false;
              });
          } else {
            addInformation(commitData)
              .then((res) => {
                this.loading = false;
                this.$message.success('新增成功');
                updateRelationStatus([relationId]);
                if (type === 'sub') {
                  this.contractBookSubmit(res);
                  return;
                }
                this.cancel();
                this.$emit('done');
              })
              .catch((e) => {
                //this.loading = false;
              });
          }
        } catch (error) {
          console.log(error);
          // 表单验证未通过，不执行保存操作
        }
      },
      async contractBookSubmit(res) {
        const data = await getDetail(this.businessId || res);
        this.processSubmitDialogFlag = true;
        let key =
          data.contractVO.type == 1
            ? 'sales_contract_approve'
            : 'contract_approve_2';
        this.$nextTick(() => {
          let params = {
            businessId: data.contractVO.id,
            businessKey: key,
            formCreateUserId: data.contractVO.createUserId,
            variables: {
              businessType: data.contractVO.categoryName,
              businessName: data.contractVO.contractName,
              businessCode: data.contractVO.contractNumber
            }
            // callBackMethodType : '1',
            // callBackMethod : 'proTargetPlanApproveApiImpl.updatePlanApprovalStatus',
            // pcHandle : '/bpm/handleTask/components/project-manage/plan-manage/submit.vue',
            // pcView : '/bpm/handleTask/components/project-manage/plan-manage/detailDialog.vue',
            // miniHandle : '',
            // miniView : '',
          };
          this.$refs.processSubmitDialogRef.init(params);
        });
        // submit({
        //   businessId: this.businessId || res,
        //   businessType: this.form.type
        //   // productionSupervisorId
        // }).then((res) => {
        //   this.cancel();
        //   this.$emit('done');
        // });
      },
      reload() {
        this.cancel();
        this.$emit('done');
      },
      handInquiry(e) {
        if (e.target.nodeName == 'I') {
          this.$set(this.form, 'sourceName', '');
          this.$set(this.form, 'sourceId', '');
          return;
        }
        this.$refs.inquiryListRef.open();
      },
      handQuotation(e) {
        if (e.target.nodeName == 'I') {
          this.$set(this.form, 'sourceName', '');
          this.$set(this.form, 'sourceId', '');
          return;
        }
        this.$refs.quotationListRef.open();
      },
      //核价单
      async changeInquiryList({ data, sourceId, sourceName }) {
        console.log(sourceId, sourceName);
        this.$set(this.form, 'sourceName', sourceName);
        this.$set(this.form, 'sourceId', sourceId);
        this.$set(this.form, 'HJQD', '');

        if (!data) return;
        console.log(data);
        this.$nextTick(() => {
          this.$refs.rawDetailListRef &&
            this.$refs.rawDetailListRef.putTableValueNew(data.rawList); //原料
          this.$refs.outputDetailListRef &&
            this.$refs.outputDetailListRef.putTableValueNew(data.outputList);
        });

        this.setValue(data);
      },
      //核价清单
      async changeInquiryDetailList({ data }) {
        if (!data) return;
        this.setValue(data);
        let contactId =
          this.form.type == 2
            ? data.contractVO.partbId
            : data.contractVO.partaId;
        let { base } = await contactDetail(contactId);

        this.$set(this.form, 'contractName', base.simpleName);
      },
      //报价单
      async changeQuotationList({ data, sourceCode, sourceName }) {
        this.setValue(data);
        this.$set(this.form, 'sourceName', sourceCode);
        this.$set(this.form, 'sourceId', data.contractVO.sourceId);
      },
      //选择采购计划
      handPlan(e) {
        if (e.target.nodeName == 'I') {
          this.$set(this.form, 'sourceName', '');
          this.$set(this.form, 'sourceId', '');
          return;
        }
        this.$refs.inquiryManageRef.open();
      },
      //选择采购计划回调
      async changeInquiryManageList(data) {
        let info = await this.getPlanInfo(data.id);
        let cusInfo = {};
        // if (info.detailList.length) cusInfo = await this.getCusInfo(info.detailList[0]?.supplierId ?? '');
        this.$set(this.form, 'sourceName', data.planName);
        this.$set(this.form, 'contractName', data.planName);
        this.$set(this.form, 'sourceId', data.id);
        this.$set(this.form, 'requireDeptId', data.requireDeptId);
        this.$set(this.form, 'requireUserId', data.requireUserId);
        this.$set(this.form, 'requireDeptName', data.requireDeptName);
        this.$set(this.form, 'requireUserName', data.requireUserName);
        //  this.getrequireUser(data.requireDeptId)
        this.form.isFirstProcess = info.isFirstProcess;
        this.$nextTick(() => {
          this.$refs.rawDetailListRef &&
            this.$refs.rawDetailListRef.putTableValueNew(info.rawDetailList); //原料
          this.$refs.outputDetailListRef &&
            this.$refs.outputDetailListRef.putTableValueNew(
              info.outputDetailList
            );
        });
        // this.$set(this.form, 'contractName', cusInfo?.base?.simpleName);
        let form = {
          contractVO: {
            ...this.form,
            requireSourceType: info.sourceType,
            requireSourceTypeName: info.sourceTypeName
          },
          productList: info.detailList || []
        };
        this.setValue(form);
        // await this.getLinkInfo(cusInfo.base.id)
      },
      //获取计划详情
      async getPlanInfo(id) {
        return Promise.resolve(await getplanDetail(id));
      },
      //获取客户详情
      async getCusInfo(id = '') {
        if (!id) return;
        return Promise.resolve(await contactDetail(id));
      },
      //选择商机
      handOpportunity(e) {
        if (e.target.nodeName == 'I') {
          this.$set(this.form, 'sourceName', '');
          this.$set(this.form, 'sourceId', '');
          return;
        }
        this.opportunityDialogFlag = true;
        this.$nextTick(() => {
          let item = {
            id: this.form.sourceId
          };
          this.$refs.opportunityDialogRef.init(item);
        });
      },
      //获取商机信息
      async getOpportunityDetail(row) {
        let res = await SJisHasGeneratedContractAPI(row.id);
        if (res) this.$message.warning('该商机已生成过合同，请注意');

        this.$set(this.form, 'sourceName', row.name);
        this.$set(this.form, 'sourceId', row.id);
        let cusInfo = await this.getCusInfo(row?.contactId ?? '');
        let info = await this.getOpportunityDetailData(row?.id ?? '');
        await this.getLinkInfo(cusInfo.base.id);
        let totalPrice = info.productList.reduce((num, cur) => {
          return num + Number(cur.totalPrice);
        }, 0);
        info.productList.forEach((item) => {
          item.discountSinglePrice =
            item.discountSinglePrice || item.singlePrice;
          item.discountTotalPrice = item.discountTotalPrice || item.totalPrice;
        });
        let discountTotalPrice = info.productList.reduce((num, cur) => {
          return num + Number(cur.discountTotalPrice);
        }, 0);
        let form = {
          contractVO: {
            ...this.form,
            partaName: cusInfo.base.name,
            partaId: cusInfo.base.id,
            partaUnifiedSocialCreditCode: cusInfo.base.unifiedSocialCreditCode,
            partaAddress: cusInfo.base.addressName + cusInfo.base.address,
            partaLinkName: cusInfo.linkList[0]?.linkName,
            partaLinkId: cusInfo.linkList[0]?.id,
            partaTel: cusInfo.linkList[0]?.mobilePhone,
            totalPrice: totalPrice,
            discountTotalPrice: discountTotalPrice
          },
          productList: info.productList || []
        };

        this.setValue(form);
        this.$set(this.form, 'contractName', row.name);
      },
      //获取商机详情
      async getOpportunityDetailData(id) {
        return Promise.resolve(await getOpportunityInfo(id));
      },

      cancel() {
        this.$nextTick(() => {
          this.activeName = 'base';
          // 关闭后，销毁所有的表单数据
          this.$refs['otherForm'] && this.$refs['otherForm'].resetFields();
          this.$refs['formRef'] && this.$refs['formRef'].resetFields();
          this.form = copyObj(this.formDef);
          this.$store.commit('concact/setDiscountAmount', 0);
          this.visible = false;
        });
      },
      //选择退货单
      handReturnOrder(e) {
        if (e.target.nodeName == 'I') {
          this.$set(this.form, 'sourceName', '');
          this.$set(this.form, 'sourceId', '');
          return;
        }
        this.returnOrderDialogFlag = true;
        // this.$nextTick(() => {
        //   this.$refs.returnOrderDialogRef.init()
        // })
      },
      //退货单
      async getReturnOrderInfo(row) {
        this.$set(this.form, 'sourceName', row.returnNo);
        this.$set(this.form, 'sourceId', row.id);
        let cusInfo = await this.getCusInfo(row?.contactId ?? '');
        let info = await this.getReturnOrderDetail(row?.id ?? '');
        await this.getLinkInfo(cusInfo.base.id);
        let totalPrice = info?.productList.reduce((num, cur) => {
          return num + Number(cur.totalPrice);
        }, 0);
        info?.redressProductList.forEach((item) => {
          item.discountSinglePrice =
            item.discountSinglePrice || item.singlePrice;
          item.discountTotalPrice = item.discountTotalPrice || item.totalPrice;
        });
        let discountTotalPrice = info?.redressProductList.reduce((num, cur) => {
          return num + Number(cur.discountTotalPrice);
        }, 0);
        let form = {
          contractVO: {
            ...this.form,
            partaName: cusInfo.base.name,
            partaId: cusInfo.base.id,
            partaUnifiedSocialCreditCode: cusInfo.base.unifiedSocialCreditCode,
            partaAddress: cusInfo.base.addressName + cusInfo.base.address,
            partaLinkName: cusInfo.linkList[0]?.linkName,
            partaLinkId: cusInfo.linkList[0]?.id,
            partaTel: cusInfo.linkList[0]?.mobilePhone,
            totalPrice: totalPrice,
            discountTotalPrice: discountTotalPrice
          },
          productList: info.redressProductList || []
        };
        this.setValue(form);
      },
      //获取退货单详情
      async getReturnOrderDetail(id) {
        return Promise.resolve(await getReturnSaleOrderrecordDetail(id));
      },

      //查找合同分类对应name
      findNameById(tree, targetId) {
        for (let i = 0; i < tree.length; i++) {
          const node = tree[i];
          if (node.id === targetId) {
            return node.name;
          }
          if (node.children && node.children.length > 0) {
            const name = this.findNameById(node.children, targetId);
            if (name) {
              return name;
            }
          }
        }
        return null;
      }
    }
  };
</script>
<style scoped lang="scss">
  .TotalAmount {
    font-size: 16px;
    padding-right: 30px;
  }
</style>
